EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_SELECT_MODEL_EVENT_SELECTED =
   EFL_EVENT_DESCRIPTION("selected");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_SELECT_MODEL_EVENT_UNSELECTED =
   EFL_EVENT_DESCRIPTION("unselected");

Efl_Object *_efl_ui_select_model_efl_object_constructor(Eo *obj, Efl_Ui_Select_Model_Data *pd);


void _efl_ui_select_model_efl_object_invalidate(Eo *obj, Efl_Ui_Select_Model_Data *pd);


Eina_Future *_efl_ui_select_model_efl_model_property_set(Eo *obj, Efl_Ui_Select_Model_Data *pd, const char *property, Eina_Value *value);


Eina_Value *_efl_ui_select_model_efl_model_property_get(const Eo *obj, Efl_Ui_Select_Model_Data *pd, const char *property);


Eina_Iterator *_efl_ui_select_model_efl_model_properties_get(const Eo *obj, Efl_Ui_Select_Model_Data *pd);


Efl_Ui_Selectable *_efl_ui_select_model_efl_ui_single_selectable_last_selected_get(const Eo *obj, Efl_Ui_Select_Model_Data *pd);


void _efl_ui_select_model_efl_ui_multi_selectable_select_mode_set(Eo *obj, Efl_Ui_Select_Model_Data *pd, Efl_Ui_Select_Mode mode);


Efl_Ui_Select_Mode _efl_ui_select_model_efl_ui_multi_selectable_select_mode_get(const Eo *obj, Efl_Ui_Select_Model_Data *pd);


void _efl_ui_select_model_efl_ui_multi_selectable_all_select(Eo *obj, Efl_Ui_Select_Model_Data *pd);


void _efl_ui_select_model_efl_ui_multi_selectable_all_unselect(Eo *obj, Efl_Ui_Select_Model_Data *pd);


Eina_Iterator *_efl_ui_select_model_efl_ui_multi_selectable_index_range_selected_ndx_iterator_new(Eo *obj, Efl_Ui_Select_Model_Data *pd);


Eina_Iterator *_efl_ui_select_model_efl_ui_multi_selectable_index_range_unselected_ndx_iterator_new(Eo *obj, Efl_Ui_Select_Model_Data *pd);


void _efl_ui_select_model_efl_ui_multi_selectable_index_range_ndx_range_select(Eo *obj, Efl_Ui_Select_Model_Data *pd, unsigned int a, unsigned int b);


void _efl_ui_select_model_efl_ui_multi_selectable_index_range_ndx_range_unselect(Eo *obj, Efl_Ui_Select_Model_Data *pd, unsigned int a, unsigned int b);


void _efl_ui_select_model_efl_ui_single_selectable_fallback_selection_set(Eo *obj, Efl_Ui_Select_Model_Data *pd, Efl_Ui_Selectable *fallback);


Efl_Ui_Selectable *_efl_ui_select_model_efl_ui_single_selectable_fallback_selection_get(const Eo *obj, Efl_Ui_Select_Model_Data *pd);


void _efl_ui_select_model_efl_ui_selectable_selected_set(Eo *obj, Efl_Ui_Select_Model_Data *pd, Eina_Bool selected);


Eina_Bool _efl_ui_select_model_efl_ui_selectable_selected_get(const Eo *obj, Efl_Ui_Select_Model_Data *pd);


static Eina_Bool
_efl_ui_select_model_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_UI_SELECT_MODEL_EXTRA_OPS
#define EFL_UI_SELECT_MODEL_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_ui_select_model_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_invalidate, _efl_ui_select_model_efl_object_invalidate),
      EFL_OBJECT_OP_FUNC(efl_model_property_set, _efl_ui_select_model_efl_model_property_set),
      EFL_OBJECT_OP_FUNC(efl_model_property_get, _efl_ui_select_model_efl_model_property_get),
      EFL_OBJECT_OP_FUNC(efl_model_properties_get, _efl_ui_select_model_efl_model_properties_get),
      EFL_OBJECT_OP_FUNC(efl_ui_selectable_last_selected_get, _efl_ui_select_model_efl_ui_single_selectable_last_selected_get),
      EFL_OBJECT_OP_FUNC(efl_ui_multi_selectable_select_mode_set, _efl_ui_select_model_efl_ui_multi_selectable_select_mode_set),
      EFL_OBJECT_OP_FUNC(efl_ui_multi_selectable_select_mode_get, _efl_ui_select_model_efl_ui_multi_selectable_select_mode_get),
      EFL_OBJECT_OP_FUNC(efl_ui_multi_selectable_all_select, _efl_ui_select_model_efl_ui_multi_selectable_all_select),
      EFL_OBJECT_OP_FUNC(efl_ui_multi_selectable_all_unselect, _efl_ui_select_model_efl_ui_multi_selectable_all_unselect),
      EFL_OBJECT_OP_FUNC(efl_ui_multi_selectable_selected_ndx_iterator_new, _efl_ui_select_model_efl_ui_multi_selectable_index_range_selected_ndx_iterator_new),
      EFL_OBJECT_OP_FUNC(efl_ui_multi_selectable_unselected_ndx_iterator_new, _efl_ui_select_model_efl_ui_multi_selectable_index_range_unselected_ndx_iterator_new),
      EFL_OBJECT_OP_FUNC(efl_ui_multi_selectable_ndx_range_select, _efl_ui_select_model_efl_ui_multi_selectable_index_range_ndx_range_select),
      EFL_OBJECT_OP_FUNC(efl_ui_multi_selectable_ndx_range_unselect, _efl_ui_select_model_efl_ui_multi_selectable_index_range_ndx_range_unselect),
      EFL_OBJECT_OP_FUNC(efl_ui_selectable_fallback_selection_set, _efl_ui_select_model_efl_ui_single_selectable_fallback_selection_set),
      EFL_OBJECT_OP_FUNC(efl_ui_selectable_fallback_selection_get, _efl_ui_select_model_efl_ui_single_selectable_fallback_selection_get),
      EFL_OBJECT_OP_FUNC(efl_ui_selectable_selected_set, _efl_ui_select_model_efl_ui_selectable_selected_set),
      EFL_OBJECT_OP_FUNC(efl_ui_selectable_selected_get, _efl_ui_select_model_efl_ui_selectable_selected_get),
      EFL_UI_SELECT_MODEL_EXTRA_OPS
   );
   opsp = &ops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_ui_select_model_class_desc = {
   EO_VERSION,
   "Efl.Ui.Select_Model",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Ui_Select_Model_Data),
   _efl_ui_select_model_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_ui_select_model_class_get, &_efl_ui_select_model_class_desc, EFL_BOOLEAN_MODEL_CLASS, EFL_UI_MULTI_SELECTABLE_INDEX_RANGE_INTERFACE, EFL_UI_SELECTABLE_INTERFACE, NULL);
